package ssw.mj.codegen;

/**
 * MircoJava Jump Label.
 * ====================
 * Forward jumps use labels which are still undefined.
 * Such jump instructions are linked in the code.
 * A fixup is made as soon as the label becomes defined.
 * Backward jumps use labels which are already defined.
 * Such jump instructions are already generated with the definite label address.
 */
public class Label {
	/**	Is the jump destination already defined? */
	private boolean defined = false;

	/**	Jump destination address or head of unresolved forward jumps. */
	private int adr;
	
	/** Generates code for a jump to this label. */
	public void put () {
		//----- put your code here -----
	}
	
	/**	Defines <code>this</code> label to be at the current pc position */
	public void here () {
		//----- put your code here -----
	}
	
	/** Defines <code>this</code> label to be at the position 
	 *	of <code>dest</code>. */
	public void setTo (Label dest) {
		//----- put your code here -----
	}

	/**	Links the forward jumps of <code>other</code> with 
	 *  those of <code>this</code>. 
	 *  NOT needed for MicroJava-Programs!
	 */
	public void add (Label other) {
		if (defined || other.defined)
			// don't: System.exit(1); // should never happen
			// but rather
			throw new Error("label already defined");
		if (adr == 0) adr = other.adr;
		else {
			int p = adr; int pos;
			do { pos = p; p = Code.get2(p); } 
			while (p != 0);
			Code.put2(pos, other.adr);
		}
	}	
}
